=== debian/changelog ===
insighttoolkit4 (4.3.2-1ubuntu2) saucy; urgency=low

  * debian/patches/bool-is-not-bool.patch: make sure our C bool type matches
    the C++ bool type.  Fixes a bug found by the test suite, caused by trying
    to pass a pointer to a C++ native 'bool' as a pointer to a C 'int' bool.
  * debian/patches/add-missing-include.patch: add a missing include of
    itkProgressReporter.h.
  * Both of these patches are already present upstream in version 4.4.2, so
    can be dropped with the next merge.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 30 Sep 2013 16:28:21 +0000

insighttoolkit4 (4.3.2-1ubuntu1) saucy; urgency=low

  * Resynchronise with Debian.  Remaining changes:
    - Revert build-dependency on libtiff5-alt-dev; not needed since Ubuntu's
      default libtiff-dev is already libtiff5-dev.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 05 Jun 2013 00:12:38 +0100

insighttoolkit4 (4.3.2-1) unstable; urgency=low

  * New upstream.
    - patches/lsm-with-system-tiff.patch: Removed.  Applied upstream.

 -- Steve M. Robbins <smr@debian.org>  Tue, 30 Apr 2013 23:09:50 -0500

insighttoolkit4 (4.3.1-3) UNRELEASED; urgency=low

  * Remove obsolete DMUA flag
  * Remove self from Uploaders

 -- Mathieu Malaterre <malat@debian.org>  Thu, 11 Apr 2013 12:03:49 +0200
